REM************************************************************************
REM
REM   Filename       :   9310test.bas     Version:  1.0
REM
REM   Entwickelt von :   CS               am 20.02.2001
REM   Gendert von   :                    am xx.xx.xxxx
REM
REM   Sprache        :   QBASIC           Betriebssystem: MS-DOS
REM
REM   Funktion       :   Testprogramm fr ANSI Protokoll X3.28 A4
REM                      Bedienung ber die RS232 Schnittstelle
REM
REM************************************************************************
REM
OPEN "COM1:9600,N,8,1" FOR RANDOM AS #3   ' RS232 INITIALISIEREN
CLS                                       ' BILDSCHIRM LSCHEN
PRINT "          DEMOPROGRAMM "
PRINT "            burster                 "
PRINT "Steuerung ber RS232 Schnittstelle  "
PRINT "bertragungsprotokoll: ANSI X3.28 A4"
PRINT
PRINT "EXIT mit #"
DIM an$(50)
DIM befehl$(50)
REM   Sonderzeichen werden definiert
STX$ = CHR$(2)
etx$ = CHR$(3)
EOT$ = CHR$(4)
ENQ$ = CHR$(5)
ACK$ = CHR$(6)
NAK$ = CHR$(21)
CR$ = CHR$(13)
lf$ = CHR$(10)
ESC$ = CHR$(27)
FF$ = CHR$(255)
select$ = "00SR" + ENQ$   'SELECTION SEQUENZ
polling$ = "00PO" + ENQ$  'POLLING SEQUENZ



WHILE befehl$ <> "#"            'Solange keine ESC Taste
LOCATE 10, 1
befehl$ = ""

LINE INPUT "Bitte Befehl eingeben: "; befehl$
IF (befehl$ = "") THEN befehl$ = "info?"
IF (befehl$ = "#") THEN END
query = 0
length = LEN(befehl$)
FOR i = 1 TO length
 IF MID$(befehl$, i, 1) = "?" THEN
  query = 1
 END IF
 IF MID$(befehl$, i, 1) = "#" THEN
  MID$(befehl$, i, 1) = ","
 END IF
NEXT i
LOCATE 19, 1
PRINT "                                                                                  "
LOCATE 20, 1
PRINT "                                                                                 "
LOCATE 21, 1
PRINT "                                                                                 "
LOCATE 22, 1
PRINT "                                                                     "
GOSUB selection
GOSUB SENDBEFEHL
LOCATE 10, 1
PRINT "                                                                           "
WEND

CLS                             'Bildschirm lschen
CLOSE #3
END                             'Programm Ende
SYSTEM                          'Kontrolle an Betriebssystem


SENDBEFEHL:                     'Subroutine Aussenden des Befehls
 LOCATE 15, 1
 PRINT "                                                                            "
 LOCATE 15, 1
 PRINT "Gesendeter Befehl: ", befehl$
 PRINT #3, STX$ + befehl$ + lf$ + FF$ + etx$  ' Start Befehl senden
 ant$ = " "                      'Antwortstring lschen
 ant$ = INPUT$(1, #3)           'Antwort einlesen
 LOCATE 17, 1
 IF (ant$ <> ACK$) THEN         'Wenn nicht ACK
  PRINT "Gert antwortet mit NAK   "       'Fehlermeldung anzeigen
 ELSE                           'ansonsten
  PRINT "                                     "       'wurde Befehl verstanden
 END IF
 PRINT #3, EOT$
IF query = 1 THEN GOSUB getpar
RETURN



getpar:                        'Subroutine zum Abholen eines Parameters
 GOSUB polling
mk1:
  ant$ = ""                     'Antwortstring lschen
  stri$ = ""                    'Mewertstring lschen
ant$ = INPUT$(1, #3)

   WHILE (ant$ <> etx$) AND (ant$ <> EOT$) 'Solange kein ETX und EOT empfangen
   IF ant$ >= CHR$(32) THEN    ' Wenn keine Sonderzeichen
    stri$ = stri$ + ant$        'Mewertstring bilden
   END IF
   ant$ = INPUT$(1, #3)         'Zeichen von RS232 einlesen
  WEND

  IF (ant$ = EOT$) THEN         'Wenn EOT empfangen
   LOCATE 22, 10                 'Zeile 18, Spalte 1
   PRINT "Kein weiterer Parameter" 'Meldung anzeigen

  ELSE
   LOCATE 19, 1                 'Zeile 20, Spalte 1
   PRINT "Empfangener Parameter: ", stri$ ' Empfangener Mewert anzeigen
   PRINT #3, ACK$
   GOTO mk1
  END IF

 RETURN


selection:                      'Subroutine fr Selection
 PRINT #3, EOT$
 ant$ = ""               'Antwortstring lschen
 PRINT #3, select$       'Selection With Response bertragen

 ant$ = INPUT$(1, #3)           'Antwort abholen
 LOCATE 12, 1
 PRINT "                                                     "
 IF (ant$ <> ACK$) THEN         'Wenn nicht ACK
  LOCATE 12, 1                  'Zeile 12, Spalte 1
  PRINT "Selection nicht erkannt"       'Fehlermeldung anzeigen
  PRINT
  PRINT ASC(ant$), ASC(ACK$)
 ELSE
  LOCATE 12, 1
  PRINT "                                                    "
  PRINT "                                                    "
  PRINT "                                                    "
 END IF
           
RETURN


polling:                        'Subroutine fr Polling
 PRINT #3, EOT$
 PRINT #3, polling$             'Polling Sequenz bertragen
RETURN


